#! /bin/sh

CONF_PATH=/mnt/mtd/ipc/tmpfs
FLAG_PATH=$CONF_PATH/wifires
NETDEV=wlan0
wifidev=wlan0
wifi_res=1
. $CONF_PATH/wifi.conf

checkwifi()
{
	wifi_res=1
	
	for i in $(seq 10)
	do
		WPA_STATE=`wpa_cli -i wlan0 -p /var/run/wpa_supplicant status`
		if echo "$WPA_STATE" | grep "wpa_state=COMPLETED"
		then
			wifi_res=0
			return
		fi
		sleep 1
	done
}

loadwifi()
{
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant remove_network 0
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant add_network
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 ssid "\"${WifiSsid}\""
	if [ $WifiEnc == "NONE" ]
	then	
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 key_mgmt NONE
	elif [ $WifiEnc == "WEP" ]
	then
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 key_mgmt NONE
		StrNum=`echo "$WifiKey" | wc -L`
		if [ $StrNum -eq  5 ]
		then
			wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_key0 "\"$WifiKey\""
		elif [ $StrNum -eq  13 ]
		then
			wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_key0 "\"$WifiKey\""
		else
			wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_key0 $WifiKey
		fi		
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_tx_keyidx 0
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 auth_alg 'OPEN SHARED'
	else
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 key_mgmt WPA-PSK
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 psk "\"$WifiKey\""
	fi
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant select_network 0
}

rm $FLAG_PATH

NETFLAG=`cat /mnt/mtd/ipc/tmpfs/netflag.dat`
if [ $NETFLAG -eq 1 ]
then
	touch $FLAG_PATH
    exit $wifi_res
fi

loadwifi
checkwifi
wpa_cli -i wlan0 -p /var/run/wpa_supplicant remove_network 0
if [ $wifi_res -eq 0 ]
then
	touch $FLAG_PATH
fi
exit $wifi_res	
