#! /bin/sh

TARGET="/mnt/mtd/ipc"
CONF="$TARGET/conf"
DRV_PATH="/mnt/mtd/ipc/modules"
MSG="/mnt/mtd/ipc/tmpfs/wps.tmp"
FLAG="/mnt/mtd/ipc/tmpfs/wps.dat"
WIFIPATH="/mnt/mtd/ipc/conf/wifi.conf"
WPAPATH="/mnt/mtd/ipc/tmpfs/wpa.conf"
WIFIMODE=0
NETDEV=wlan0
NETINFO=$CONF/config_net.ini
NETPRIV=$CONF/config_priv.ini
PLATFORM=$CONF/config_platform.ini
DEF_IPADDR="192.168.1.88"
DEF_GATEWAY="192.168.1.1"
PARAM=0

wpa_run()                                                                                                             
{                                                                                                         
	echo "ctrl_interface=/var/run/wpa_supplicant" > $WPAPATH
	echo "eapol_version=1" >> $WPAPATH                                                                
	echo "fast_reauth=1" >> $WPAPATH                                                             
	echo "update_config=1" >> $WPAPATH                                                                                                 
	echo "network={" >> $WPAPATH                                                                                                                                                      
#	echo "    ssid=\"example\"" >> $WPAPATH                                                                                    
	echo "    proto=WPA" >> $WPAPATH                                                                                           
	echo "    key_mgmt=WPA-PSK" >> $WPAPATH                                                                                          
	echo "    pairwise=CCMP TKIP" >> $WPAPATH                                                                                                                              
	echo "    group=CCMP TKIP WEP104 WEP40" >> $WPAPATH                                                                                                                      
	echo "    psk=06b4be19da289f475aa46a33cb793029d4ab3db7a23ee92382eb0106c72ac7bb" >> $WPAPATH                
	echo "    priority=2" >> $WPAPATH                                                               
	echo "}" >> $WPAPATH                                   
	echo "" >> $WPAPATH                            
	wpa_supplicant -B -D wext -i wlan0  -c $WPAPATH        
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant remove_network 0              
}  

setwifista()
{
	cp $WIFIPATH $TARGET/tmpfs/wifi.conf
	$TARGET/wifiset.sh $PARAM
}

loadNetwork()
{
    dhcp1=`grep dhcp $NETINFO | awk -F "\"" '{print $2}'`
    ipaddr1=`grep ipaddr $NETINFO | awk -F "\"" '{print $2}'`
    gateway1=`grep gateway $NETINFO | awk -F "\"" '{print $2}'`
    netmask1=`grep netmask $NETINFO | awk -F "\"" '{print $2}'` 

    gat1=`echo $ipaddr1 | awk -F "." '{print $1}'`
    gat2=`echo $ipaddr1 | awk -F "." '{print $2}'`
    gat3=`echo $ipaddr1 | awk -F "." '{print $3}'`
    gat4=`echo $ipaddr1 | awk -F "." '{print $4}'`
    gateway2="$gat1.$gat2.$gat3.1"         

        if [ $dhcp1 = "y" ] 
        then
                $TARGET/dhcp.sh $NETDEV &
                sleep 5
                return 0
        fi   

        if ! ifconfig $NETDEV $ipaddr1 netmask $netmask1
        then
                ifconfig $NETDEV $DEF_IPADDR netmask 255.255.255.0
        fi

        if ! route add default gw $gateway1
        then
                if ! route add default gw $gateway2
                then
                        route add default gw $DEF_GATEWAY
                fi
        fi

        return 0      
}

loadAround()
{
    $TARGET/facddns.sh
    $TARGET/upnpmap.sh
    $TARGET/th3ddns.sh
    $TARGET/loadp2p.sh 1 &
}

NETFLAG=`cat /mnt/mtd/ipc/tmpfs/netflag.dat`

killall udhcpc
killall udhcpd
killall hostapd
killall hostapds
killall upnp_map
killall updatewifi
killall onvif

wpa_cli terminate
wpa_run
wpa_cli -p/var/run/wpa_supplicant wps_pbc any
for i in $(seq 25)
do
        wpa_cli -p/var/run/wpa_supplicant status > $MSG
        if grep -wr ssid= $WPAPATH
        then
                break
        fi
        if grep -E "wpa_state=DISCONNECTED|wpa_state=INTERFACE_DISABLED" $MSG
        then                                                                
		wpa_cli terminate
		wpa_run
		wpa_cli -p/var/run/wpa_supplicant wps_pbc any
        fi
        sleep 4
done

wpa_cli -p/var/run/wpa_supplicant remove_network 0

if [ $i -eq 25 ]
then
        echo "error" > $FLAG
        exit 1
fi

SSID=`grep -wr ssid $WPAPATH | awk -F "=" '{print $2}'`
AuthType=`grep -wr key_mgmt $WPAPATH | awk -F "=" '{print $2}'`
Key=`grep -wr psk $WPAPATH | awk -F "=" '{print $2}'`

if [ $AuthType == "NONE" ]
then
	EncrypType=OPEN
fi
if [ $AuthType == "WPA-PSK" ]
then
	EncrypType=AES
fi

echo $AuthType
echo $EncrypType

echo "WifiEnable=1" > $WIFIPATH
echo "WifiType=Infra" >> $WIFIPATH
echo "WifiMode=$AuthType" >> $WIFIPATH
echo "WifiEnc=$EncrypType" >> $WIFIPATH
if echo $SSID | grep -E '^\"'
then
	echo "WifiSsid=$SSID" >> $WIFIPATH
else
	echo "WifiSsid=\"$SSID\"" >> $WIFIPATH
fi
if echo $Key | grep -E '^\"'
then
	echo "WifiKey=$Key" >> $WIFIPATH 
else
	echo "WifiKey=\"$Key\"" >> $WIFIPATH
fi
sync

echo "good" > $FLAG

if [ $NETFLAG -eq 0 ]
then
        exit 0
fi

killall udhcpc
killall udhcpd
killall hostapd
killall hostapds
killall upnp_map
killall updatewifi
killall onvif
touch /mnt/mtd/ipc/tmpfs/wifi.ok
setwifista
loadNetwork
loadAround

exit 0