#! /bin/sh

WF_SSID=0
WF_KEY=0
WF_Mode=0
WF_Enc=0
WF_RES=0
PHONE=0
NETDEV=wlan0
TMP_PATH="/mnt/mtd/ipc/tmpfs"
WIFIPATH="/mnt/mtd/ipc/conf/wifi.conf"
WIFITMP="/mnt/mtd/ipc/tmpfs/wifi.conf"

checkwifi()
{
	WF_RES=1

	for i in $(seq 10)
	do
		WPA_STATE=`wpa_cli -i wlan0 -p /var/run/wpa_supplicant status`
		if echo "$WPA_STATE" | grep "wpa_state=COMPLETED"
		then
			WF_RES=0
			return
		fi
		sleep 1
	done
}

updatewifi()
{
	echo "WifiEnable=1" > $WIFIPATH
	echo "WifiType=Infra" >> $WIFIPATH
	echo "WifiMode=$WF_Mode" >> $WIFIPATH
	echo "WifiEnc=$WF_Enc" >> $WIFIPATH
	echo "WifiSsid=\"$WF_SSID\"" >> $WIFIPATH
	echo "WifiKey=\"$WF_KEY\"" >> $WIFIPATH
	/mnt/mtd/ipc/char_encode $WIFIPATH
}

returnok()
{
	if [ $WF_RES -eq 0 ]
	then
		updatewifi
		exit 0
	fi
}

wifi_wpa_auto()
{
	WF_Mode=WPA2PSK
	WF_Enc=AES

	wpa_cli -i wlan0 -p /var/run/wpa_supplicant remove_network 0
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant add_network
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 ssid "\"${WF_SSID}\""
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 key_mgmt WPA-PSK
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 psk "\"$WF_KEY\""
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant select_network 0	
	
	checkwifi
	returnok
}

wifi_wep_auto()
{
	WF_Mode=WEPAUTO
	WF_Enc=WEP

	wpa_cli -i wlan0 -p /var/run/wpa_supplicant remove_network 0
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant add_network
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 ssid "\"${WF_SSID}\""
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 key_mgmt NONE
	StrNum=`echo "$WF_KEY" | wc -L`
	if [ $StrNum -eq  5 ]
	then
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_key0 "\"$WF_KEY\""
	elif [ $StrNum -eq  13 ]
	then
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_key0 "\"$WF_KEY\""
	else
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_key0 $WF_KEY
	fi		
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_tx_keyidx 0
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 auth_alg 'OPEN SHARED'
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant select_network 0
	
	checkwifi
	returnok
}

wifi_none_open()
{
	WF_Mode=OPEN
	WF_Enc=NONE

	wpa_cli -i wlan0 -p /var/run/wpa_supplicant remove_network 0
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant add_network
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 ssid "\"${WF_SSID}\""
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 key_mgmt NONE
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant select_network 0
	
	checkwifi
	returnok
}

loadwf()
{
	. $WIFITMP
	WF_SSID=$WifiSsid
	WF_KEY=$WifiKey
}

loadwificonf()
{
. $TMP_PATH/twifi.conf
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant remove_network 0
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant add_network
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 ssid "\"${WifiSsid}\""
	if [ $WifiEnc == "NONE" ]
	then	
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 key_mgmt NONE
	elif [ $WifiEnc == "WEP" ]
	then
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 key_mgmt NONE
		StrNum=`echo "$WifiKey" | wc -L`
		if [ $StrNum -eq  5 ]
		then
			wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_key0 "\"$WifiKey\""
		elif [ $StrNum -eq  13 ]
		then
			wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_key0 "\"$WifiKey\""
		else
			wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_key0 $WifiKey
		fi		
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 wep_tx_keyidx 0
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 auth_alg 'OPEN SHARED'
	else
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 key_mgmt WPA-PSK
		wpa_cli -i wlan0 -p /var/run/wpa_supplicant set_network 0 psk "\"$WifiKey\""
	fi
	wpa_cli -i wlan0 -p /var/run/wpa_supplicant select_network 0
}

chkonlyIDKey()
{
	loadwf
	wifi_wpa_auto
	wifi_wep_auto
	wifi_none_open
}

setwifival()
{
. $TMP_PATH/twifi.conf
	echo "WifiEnable=1" > $WIFIPATH
	echo "WifiType=Infra" >> $WIFIPATH
	echo "WifiMode=$WifiMode" >> $WIFIPATH
	echo "WifiEnc=$WifiEnc" >> $WIFIPATH
	echo "WifiSsid=\"$WifiSsid\"" >> $WIFIPATH
	echo "WifiKey=\"$WifiKey\"" >> $WIFIPATH
	/mnt/mtd/ipc/char_encode $WIFIPATH
}

PHONE=$1
if ! /mnt/mtd/ipc/wifiget $WIFITMP
then
	chkonlyIDKey
	exit 1
fi
loadwificonf
WF_RES=0
if [ $PHONE -eq 1 ]
then
	checkwifi
fi
if [ $WF_RES -eq 0 ]
then
	setwifival
fi
exit $WF_RES
