var Camera = {
	imageMinHeight: 200,
	imageOrigWidth: 0,
	imageOrigHeight: 0,
	imageWidth: 1280,
	imageHeight: 720,
	imageScale: 1,
	lastMotionDateTime: null,
	imageLoaded: true,
	imageError: true,
	maskCols: 16,
	maskRows: 10,


	init: function() {
		var self = this;
		//alert("init camera");
		//alert(windowSize().width);
		this.cameraWrapper = document.getElementById("js-camera-wrapper");
		this.cameraImage = document.getElementById("js-camera-image");
		this.cameraImageTmp = document.getElementById("js-camera-image-tmp");
		this.cameraMessage = document.getElementById("js-camera-message");
		this.cameraRefresh = document.getElementById("js-camera-refresh");
		this.cameraMotionBox = document.getElementById("js-camera-motion-box");
		this.cameraZones = document.getElementById("js-zones-container");
		this.cameraMaskdata = document.getElementById("js-maskdata");
		this.cameraWebcamExtra = document.getElementById("js-webcam-extra");
		this.cameraNetcamExtra = document.getElementById("js-netcam-extra");


		this.cameraTypeRadio = document.getElementsByClassName("js-camera-type-radio");


		this.motionMaskHex = 'FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF';
		if(typeof maskdata != 'undefined')
			this.motionMaskHex = maskdata;
		while(this.motionMaskHex.length < 40)
			this.motionMaskHex += 'F';

		self.camera = getParameterByName("camera");

    //self.updateImage();
		//self.updateInitialMotion();
		//setInterval(function() {
		//	self.updateImage();
		//}, 10000);
		//setInterval(function() {
		//	self.updateMotion();
		//}, 1000);

		if(this.cameraRefresh)
			this.cameraRefresh.onclick = function(e) {
				if(self.imageLoaded) {
					e.stopPropagation();
					self.cameraRefresh.className += ' b-camera__refresh_rotate';
					self.updateImage();
				}
			};

		if(this.cameraImage)
			this.cameraImage.onclick = function(e) {
				// self.updateImage();
				return false;
			};

		//if(this.cameraZones) {
		//	this.initZones();
		//}

		//if(this.cameraTypeRadio && this.cameraTypeRadio.length > 0) {
		//	this.initCameraTypeRadio();
		//}

	},

	initCameraTypeRadio: function() {
		var self = this;

		for (var i = 0, len = this.cameraTypeRadio.length; i < len; i++) {
			this.cameraTypeRadio[i].onchange = function(e) {
				self.applyCameraSelectedType();
			}
		}

		this.applyCameraSelectedType();
	},

	applyCameraSelectedType: function() {
		switch(this.getCameraSelectedType()) {
			case "webcam":
				this.cameraWebcamExtra.style.display='block';
				this.cameraNetcamExtra.style.display='none';
				break;
			case "netcam":
				this.cameraWebcamExtra.style.display='none';
				this.cameraNetcamExtra.style.display='block';
				break;
		}
	},

	getCameraSelectedType: function() {
		var self = this;
		for (var i = 0, len = this.cameraTypeRadio.length; i < len; i++) {
			if (this.cameraTypeRadio[i].checked)
				return this.cameraTypeRadio[i].value;
		}
		return null;
	},

	initZones: function() {
		var self = this;
		this.cameraZones.onclick = function(e) {
			if (window.event)
				e = event.srcElement;		   //assign the element clicked to e (IE 6-8)
			else
				e = e.target;				   //assign the element clicked to e

			var row = parseInt(e.getAttribute("data-row"), 10);
			var col = parseInt(e.getAttribute("data-col"), 10);
			var val = 1;

			if (e.className && e.className.indexOf('b-zcontent') != -1) {
				if(e.className.indexOf('b-zcontent_disabled') != -1) {
					e.className = 'b-zcontent';
					val = 1;
				}
				else {
					e.className = 'b-zcontent b-zcontent_disabled';
					val = 0;
				}
				self.maskArr[row][col] = val;
				self.cameraMaskdata.value = self.getMaskHex(self.maskArr);

			}
		}

		this.maskArr = this.getMaskArr(this.motionMaskHex);
		//console.log(this.maskArr);
		this.generateZones();
		//console.log(this.motionMaskHex);
		//console.log(this.getMaskHex(this.maskArr));
	},

	generateZones: function() {
		for(var row = 0; row < this.maskRows; row++)
			for(var col = 0; col < this.maskCols; col++) {
				var disabled = false;
				if(this.maskArr[row] && this.maskArr[row][col] == '0')
					disabled = true;
				this.cameraZones.innerHTML += '<div class="b-zone"><div class="b-zcontent ' + (disabled?"b-zcontent_disabled":"") + '" data-row="'+row+'" data-col="'+col+'"></div></div>';
			}

	},
	updateImage: function() {
    	this.cameraImage.src = "/cgi-bin/camera_image.cgi?" + (new Date()).getTime();
        var self = this;
    	this.cameraImage.onload = function() {
            self.cameraRefresh.className = "b-camera__refresh";
            self.cameraImage.onload = null;
        }
		return;


		if(self.imageLoaded && self.cameraImage) {

			self.cameraImage.onload = function() {
				self.imageLoaded = true;
				self.imageError = false;
				self.cameraImage.style.visibility = 'visible';
				if(self.cameraMessage)
					self.cameraMessage.style.display = 'none';
				if(self.cameraRefresh)
					self.cameraRefresh.style.display = 'none';
				if(self.imageOrigWidth == 0) {

					self.cameraImageTmp.onload = function() {
						self.imageOrigWidth = self.cameraImageTmp.width;
						self.imageOrigHeight = self.cameraImageTmp.height;
						//console.log("set w = " + self.imageOrigWidth);
						self.updateWH(windowSize());
						self.cameraImageTmp.style.display = 'none';
					};
					self.cameraImageTmp.src = self.cameraImage.src;
				}
				if(self.cameraRefresh)
					self.cameraRefresh.className = 'b-camera__refresh';
				//console.log(self.cameraImage.height);
			}
			self.cameraImage.onerror = function() {
				self.imageLoaded = true;	//чтобы можно было еще делать запрос
				self.imageError = true;
				self.showImageError();
				if(self.cameraRefresh)
					self.cameraRefresh.className = 'b-camera__refresh';
				//console.log("404!");
			}

			self.imageLoaded = false;
			self.cameraImage.src = settings.camera_image_url + "?camera=" + self.camera + "#" + (new Date()).getTime();
		}

		//использовать # вместо ?, чтобы не было утечки памяти из-за кеширования (хотя отключено)

	},

	updateInitialMotion: function() {
		if(typeof motionInitial != 'undefined' && motionInitial.img_width)
			this.onGetImageInfo(motionInitial);
		else
			if(this.cameraMotionBox)
				this.cameraMotionBox.style.display = 'none';
	},

	updateMotion: function() {
		var self = this;

		Ajax.request({
			url: settings.camera_motion_url + "?camera=" + self.camera,
			method: 'get',
			json: true,
			data: {
			}
		})
		.done(function(result) {
				//console.log("motion", result);
				if(result && result.img_width)
					self.onGetImageInfo(result);
				else
					if(this.cameraMotionBox)
						self.cameraMotionBox.style.display = 'none';
		})
		.fail(function(xhr) {
			//console.log("fail", xhr);
			if(self.cameraMotionBox)
				self.cameraMotionBox.style.display = 'none';
		});
	},
	showImageError: function() {
		var self = this;
		//self.cameraImage.src = "images/1x1.gif";
		self.cameraImage.style.visibility = 'hidden';
		if(self.cameraMessage) {
			self.cameraMessage.style.display = 'block';
			self.cameraMessage.innerHTML = i18n("camera_no_image");
		}
		if(self.cameraRefresh)
			self.cameraRefresh.style.display = 'block';

	},
	onGetImageInfo: function(data) {
		var self = this;
		data.img_width = parseInt(data.img_width, 10);
		data.img_height = parseInt(data.img_height, 10);
		if(self.imageOrigWidth != data.img_width || self.imageOrigHeight != data.img_height) {
			self.imageOrigWidth = data.img_width;
			self.imageOrigHeight = data.img_height;
			self.updateWH(windowSize());
		}

		if(self.cameraMotionBox) {
			if(!self.imageError && self.lastMotionDateTime != data.datetime) {
				var width = parseInt(data.motion_width, 10) / self.imageScale;
				var height = parseInt(data.motion_height, 10) / self.imageScale;
				self.cameraMotionBox.style.width = width + 'px';
				self.cameraMotionBox.style.height = height + 'px';
				self.cameraMotionBox.style.left = parseInt(data.motion_center_x, 10) / self.imageScale - width / 2.0 + 'px';
				self.cameraMotionBox.style.top = parseInt(data.motion_center_y, 10) / self.imageScale - height / 2.0 + 'px';
				self.cameraMotionBox.style.display = 'block';
				self.lastMotionDateTime = data.datetime;
			}
			else
				self.cameraMotionBox.style.display = 'none';
		}
	},

	getExtraHeight: function() {
		var height = 0;
		if(this.cameraZones)
			height += 70;
		return height;
	},

	updateWH: function(size) {

		var ration = this.imageOrigWidth / this.imageOrigHeight;

		var imageCalcHeight = size.height - 40 - (App.header.offsetHeight + App.menus.offsetHeight + this.getExtraHeight());
		if(imageCalcHeight < this.imageMinHeight)
			imageCalcHeight = this.imageMinHeight;

		var imageCalcWidth = size.width - 20;

		if(imageCalcHeight * ration >= imageCalcWidth) {
			this.imageWidth = imageCalcWidth;
			this.imageHeight = this.imageWidth / ration;
		}
		else {
			this.imageHeight = imageCalcHeight;
			this.imageWidth = this.imageHeight * ration;
		}

		if(this.imageWidth && this.imageHeight) {
			this.imageScale = this.imageOrigWidth / this.imageWidth;

			this.cameraImage.style.width = this.imageWidth + 'px';
			this.cameraImage.style.height = this.imageHeight + 'px';

			this.cameraWrapper.style.width = this.imageWidth + 'px';
			this.cameraWrapper.style.height = this.imageHeight + 'px';
		}
	},

	getMaskArr: function(maskHex) {
		//console.log(maskHex);
		var mask = [];
		var n = 0;
		for(var i = 0; i < maskHex.length; i++) {
			var hex = maskHex[i];
			var bin = pad(parseInt(hex,16).toString(2), 4, '0');
			//console.log(hex, bin);
			for(var j = 0; j < bin.length; j++) {
				var row = integerDivision(n, this.maskCols);
				var col = n % this.maskCols;
				var val = bin[j];
				//alert(row + ' ' + col + ' = ' + val);
				if(!mask[row])
					mask[row] = [];
				mask[row][col] = val;
				n++;
			}

		}
		return mask;
	},

	getMaskHex: function(maskArr) {
		var maskHex = '';
		var binStr = '';
		for(var row = 0; row < this.maskRows; row++)
			for(var col = 0; col < this.maskCols; col++) {
				//console.log(maskArr[row][col]);
				if(maskArr[row])
					binStr += maskArr[row][col];
				else
					binStr += '1';
				if(binStr.length == 4) {
					maskHex += parseInt(binStr,2).toString(16);
					binStr = '';
				}
			}
		return maskHex.toUpperCase();
	}
};
