var App = {

	init: function() {
		this.header = document.getElementById("js-header");
		this.menus = document.getElementById("js-menus");
		this.loader = document.getElementById("js-loader");

		this.hideLoader();

		if(typeof Camera != "undefined")
			Camera.init();
		if(typeof Wifi != "undefined")
			Wifi.init();
		if(typeof Ip != "undefined")
			Ip.init();
		if(typeof Update != "undefined")
			Update.init();
		addEvent(window, "resize", function(event) {
			if(typeof App != "undefined")
				App.updateWH();
		});
		this.updateWH();
		// this.getConnectionStatus();

        var buttons = document.getElementsByClassName("b-button");
        for(var b = 0; b < buttons.length; b++) {
            var button = buttons[b];
            button.onclick = function() {
                if(this.classList.contains('loading')) {
                    return false;
				}
            	this.classList.add('loading');
            };
        }
	},

	hideLoader: function() {
		if(this.loader)
			this.loader.style.display='none';
	},

	updateWH: function() {
		var size = windowSize();
		if(typeof Camera != "undefined")
			Camera.updateWH(size);
	},

	getConnectionStatus: function() {
        this.connection = document.getElementById("js-connection");
		var self = this;
		Ajax.request({
			url: "/cgi-bin/connection.cgi",
			method: 'get',
			json: true,
			data: {
			}
		})
		.done(function(result) {
			if(result)
				self.updateConnection(result);
			else
				self.updateConnection(null);

		})
		.fail(function(xhr) {
			self.updateConnection(null);
		});
	},

	getConnectionText: function(code) {
		return code === 0 ? i18n("connection_ok") : i18n("connection_error");
	},

	updateConnection: function(data) {
		if(data) {
			this.connection.innerHTML = this.getConnectionText(data.connection_error);
		}
		else {
			this.connection.innerHTML = '?';
		}
	}
};

if (document.addEventListener) {
  document.addEventListener("DOMContentLoaded", function() {
   	App.init();
  }, false);
}
else {
  window.onload = function() {
  	App.init();
  };
}

