if(typeof  console == "undefined") {
	console = {
		log: function(text1, text2) {
			if(typeof text1 == "object")
				text1 = JSON.stringify(text1);
			alert(text1);
			if(text2) {
				if(typeof text2 == "object")
					text2 = JSON.stringify(text2);
				alert(text2);
			}

		}
	};

}

function windowSize() {
	var myWidth = 0, myHeight = 0;
	if( typeof( window.innerWidth ) == 'number' ) {
		//Non-IE
		myWidth = window.innerWidth;
		myHeight = window.innerHeight;
	} else if( document.documentElement && ( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) {
		//IE 6+ in 'standards compliant mode'
		myWidth = document.documentElement.clientWidth;
		myHeight = document.documentElement.clientHeight;
	} else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) {
		//IE 4 compatible
		myWidth = document.body.clientWidth;
		myHeight = document.body.clientHeight;
	}
	return { "width": myWidth, "height": myHeight };
}

var addEvent = function(elem, type, eventHandle) {
	if (elem == null || typeof(elem) == 'undefined') return;
	if ( elem.addEventListener ) {
		elem.addEventListener( type, eventHandle, false );
	} else if ( elem.attachEvent ) {
		elem.attachEvent( "on" + type, eventHandle );
	} else {
		elem["on"+type]=eventHandle;
	}
};

var Ajax = {
	request: function(ops) {
		if(typeof ops == 'string') ops = { url: ops };
		ops.url = ops.url || '';
		ops.method = ops.method || 'get'
		ops.data = ops.data || {};
		if(ops.json) {
			if(typeof ops.headers != 'object')
				ops.headers = {};
			ops.headers['Content-Type'] = 'application/json; charset=utf-8';
		}
		var getParams = function(data, url) {
			var arr = [], str;
			for(var name in data) {
				arr.push(name + '=' + encodeURIComponent(data[name]));
			}
			str = arr.join('&');
			if(str != '') {
				return url ? (url.indexOf('?') < 0 ? '?' + str : '&' + str) : str;
			}
			return '';
		}
		var api = {
			host: {},
			process: function(ops) {
				var self = this;
				this.xhr = null;
				if(window.ActiveXObject) { this.xhr = new ActiveXObject('Microsoft.XMLHTTP'); }
				else if(window.XMLHttpRequest) { this.xhr = new XMLHttpRequest(); }
				if(this.xhr) {
					this.xhr.onreadystatechange = function() {
						if(self.xhr.readyState == 4 && self.xhr.status == 200) {
							var result = self.xhr.responseText;
							if(ops.json === true && typeof JSON != 'undefined') {
								result = JSON.parse(result);
							}
							self.doneCallback && self.doneCallback.apply(self.host, [result, self.xhr]);
						} else if(self.xhr.readyState == 4) {
							self.failCallback && self.failCallback.apply(self.host, [self.xhr]);
						}
						self.alwaysCallback && self.alwaysCallback.apply(self.host, [self.xhr]);
					}
				}
				if(ops.method == 'get') {
					this.xhr.open("GET", ops.url + getParams(ops.data, ops.url), true);
				} else {
					this.xhr.open(ops.method, ops.url, true);
					this.setHeaders({
						'X-Requested-With': 'XMLHttpRequest',
						'Content-type': 'application/x-www-form-urlencoded'
					});
				}
				if(ops.headers && typeof ops.headers == 'object') {
					this.setHeaders(ops.headers);
				}
				setTimeout(function() {
					ops.method == 'get' ? self.xhr.send() : self.xhr.send(getParams(ops.data));
				}, 20);
				return this;
			},
			done: function(callback) {
				this.doneCallback = callback;
				return this;
			},
			fail: function(callback) {
				this.failCallback = callback;
				return this;
			},
			always: function(callback) {
				this.alwaysCallback = callback;
				return this;
			},
			setHeaders: function(headers) {
				for(var name in headers) {
					this.xhr && this.xhr.setRequestHeader(name, headers[name]);
				}
			}
		}
		return api.process(ops);
	}
}

function getParameterByName(name) {
	name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
	var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
		results = regex.exec(location.search);
	return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

function pad(n, width, z) {
	z = z || '0';
	n = n + '';
	return n.length >= width ? n : new Array(width - n.length + 1).join(z) + n;
}

function integerDivision(x, y){
	return x/y>>0
}