var Wifi = {
	updating: false,
	showPassword: false,

	init: function() {
		var self = this;
		this.wifi_searching = document.getElementById("js-wifi-list__searching");
		this.wifi_none = document.getElementById("js-wifi-list__none");
		this.wifi_list = document.getElementById("js-wifi-list");
		this.wifi_refresh = document.getElementById("js-refresh");

		this.ssid = document.getElementById("ssid");
		this.ssidText = document.getElementById("ssidText");
		this.encryption = document.getElementById("encryption");
		this.mode = document.getElementById("mode");
		this.enc = document.getElementById("enc");
		this.key = document.getElementById("key");
		this.keyEye = document.getElementById("key-eye");
		this.keyWrapper = document.getElementById("key-wrapper");

		this.wifi_searching.style.display='block';
		this.wifi_none.style.display='none';
		this.wifi_list.style.display='none';

		this.wifi_refresh.onclick = function() {
			if(!self.updating)
				self.getList();
		};

		this.keyEye.onclick = function() {
			self.showPassword = !self.showPassword
			self.key.type = self.showPassword ? 'text' : 'password';
			self.keyEye.className = 'b-form-field__eye' + (self.showPassword ? ' active' : '');
		};

		this.getList();
	},

	getStrength: function(percent) {
		if(percent) {
			if(percent > 90)
				return 5;
			if(percent > 70)
				return 4;
			if(percent > 50)
				return 3;
			if(percent > 30)
				return 2;
			return 1;
		}
		else
			return 0;
	},

	setUpdateStatus: function(updating) {
		this.updating = updating;
		if(updating) {
			this.wifi_refresh.className = 'b-refresh b-refresh_animation';
			this.wifi_searching.style.display='block';
			this.wifi_none.style.display='none';
			this.wifi_list.style.display='none';
		}
		else {
			this.wifi_searching.style.display='none';
			this.wifi_refresh.className = 'b-refresh';
		}
	},

	getList: function() {
		var self = this;
		this.setUpdateStatus(true);
		Ajax.request({
			url: settings.wifi_list_url,
			method: 'get',
			json: true,
			data: {
			}
		})
		.done(function(result) {
				//console.log("motion", result);
				if(result && result.data)
					self.updateList(result.data);
				else
					self.updateList(null);

				self.setUpdateStatus(false);

		})
		.fail(function(xhr) {
			self.updateList(null);
			self.setUpdateStatus(false);
		});
	},

	updateList: function(data) {
		if(data && data.length > 0) {
			this.wifi_list.innerHTML = '';
			this.wifi_list.style.display='block';

			for(var i = 0; i < data.length; i++) {
				this.wifi_list.innerHTML += "\
				<div class='b-wifi-list__item "+ (data[i].selected?'b-wifi-list__item_selected':'') + (this.getStrength(data[i].signal) < 3 ? "b-wifi-list__item_low" : "") + "' onclick=\"Wifi.selectAP(this, " + i + ");\">\
					<div class='b-wifi-list__item__name'>" + data[i].ssid + "</div>\
					<div class='b-wifi-list__item__encryption' data-signal='" + this.getStrength(data[i].signal) + "' data-mode='"+data[i].mode+"' data-enc='"+data[i].enc+"'>" + ((data[i].mode != "OPEN") ? data[i].mode : i18n("wifi_no_password")) + "</div>\
					<div class='b-wifi-list__item__strength'>\
						<div class='b-wifi-bar b-wifi-bar_" + this.getStrength(data[i].signal) + "'></div>\
					</div>\
				</div>";
			}
		}
		else {
			this.wifi_none.style.display='block';
		}
	},
	selectAP: function(el, index) {
		var enc = '';
		var mode = '';
		var signal = 0;
		var encryption = el.getElementsByClassName('b-wifi-list__item__encryption');
		if(encryption && encryption.length) {
			enc = encryption[0].getAttribute("data-enc");
			mode = encryption[0].getAttribute("data-mode");
			signal = encryption[0].getAttribute("data-signal");
		}

		if(signal < 3) {
			alert(i18n("wifi_strength_alert"));
			return;
		}

		var wifiList = this.wifi_list.querySelectorAll(".b-wifi-list__item");
		for (var i = 0; i < wifiList.length; i++) {
			wifiList[i].className = 'b-wifi-list__item' + ((i === index) ? ' b-wifi-list__item_selected' : '');
		}

		var name = el.getElementsByClassName('b-wifi-list__item__name');
		if(name && name.length)
			name = name[0].innerHTML;
		else
			name = '';

		this.ssid.value = name;
		this.ssidText.innerHTML = name;
		this.enc.value = enc;
		this.mode.value = mode;
		this.key.value = '';

		this.keyWrapper.style.display = (mode == 'OPEN') ? 'none' : 'block';
		this.encryption.innerHTML = (mode == 'OPEN') ? i18n("wifi_no_password") : (i18n("wifi_encryption") + ': ' + mode);
	}
};
